require 'model'

class App
  attr_accessor :user, :records
  
  def initialize
    @case_records = []
  end

  def current_record
    @case_records.last
  end

  def current_visit
    current_record.visits.last
  end

  def current_audit
    current_record.audits.last
  end

  # Actions taken on behalf of a user. The app's interface.

  def login(keys)
    @user = keys['login']
    :main_page
  end

  def new_case(keys)
    :gather_case_input_page
  end
  
  def record_case(keys)
    @case_records << CaseRecord.new
    current_record.client = keys['client']
    current_record.clinic_id = keys['clinic_id']
    :case_display_page
  end

  def add_visit(keys)
    :gather_visit_input_page
  end

  def record_visit(keys)
    current_record.visits << Visit.new
    current_visit.diagnosis = keys['diagnosis']
    current_visit.charges = keys['charges']
    current_visit.comments = keys['comments']
    :case_display_page
  end

  def add_audit(keys)
    :gather_audit_input_page
  end

  def record_audit(keys)
    current_record.audits << Audit.new
    current_audit.auditor = keys['auditor']
    current_audit.variance = keys['variance']
    :case_display_page
  end
  
end
