require 'browser'

class Browser

  def self.make_command(name, start_action, fields, finish_action)
    command = "def #{name}(#{fields.join(', ')});"
    command << "press('#{start_action.inspect}');" if start_action

    fields.each { | field |
      command << "enter(#{field.inspect}, #{field});"
    }
    command << "press(#{finish_action.inspect}); end"
    module_eval(command)
  end

  make_command(:login, nil, [:password, :login], :login)
  make_command(:new_case, :new_case, [:client, :clinic_id], :record_case)
  make_command(:new_visit, :add_visit,
               [:diagnosis, :charges, :comments], :record_visit)
  make_command(:new_audit, :add_audit, [:auditor, :variance], :record_audit)
end
