#!/usr/local/bin/ruby

require 'path-cache'
require 'getoptlong'

STORAGE_DIR = 'snaps'   # Yeah, I should use Pathname.
server = XMLRPC::Client.new("localhost", "/side-channel", 8080)
cache = PathCache.new(STORAGE_DIR)

opts = GetoptLong.new( [ '--snap', '--snapshot', '-s', GetoptLong::NO_ARGUMENT],
                       [ '--open', '-o', GetoptLong::NO_ARGUMENT])

action = :replay_path
open_browser = false
opts.each { | opt, arg |
  case opt
  when '--snap'
    action = :remember_path
  when '--open'
    open_browser = true
  end
}

cachefile = ARGV[0]
cache.send(action, "#{STORAGE_DIR}/#{cachefile}")

if open_browser
  case RUBY_PLATFORM
  when /darwin/
    `open -a /Applications/Safari.app/ http://localhost:8080/refresh`
  else
    puts "I don't know how to open your browser. (Right now, I only know about Safari on Mac OS X.)"
  end
end


exit(0)
